<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <div id='app'>
        <router-link to='/comp1'>Component 1</router-link>
        <router-link to='/comp2'>Component 2</router-link>
        <router-link to='/comp3'>Component 3</router-link>
        <router-view></router-view>
    </div>
    <script src="https://unpkg.com/vue/dist/vue.js"></script>
    <script src="https://unpkg.com/vue-router/dist/vue-router.js"></script>
    <script>
        let user = { login: true, role: 'admin'}
        const Comp1 = { template: '<div>Ini Component 1</div>' }
        const Comp2 = { template: '<div>Ini Component 2</div>',
                        beforeRouteEnter(to, from, next){
                            if(to.matched.some(record => record.meta.login)){
                                if(!user.login){
                                    alert('Halaman ini hanya untuk user!')
                                    next(false)
                                } else {
                                    alert('Berhasil masuk sebagai user')
                                    next()
                                }
                            } else {
                                next()
                            }
                        } }
        const Comp3 = { template: '<div>Ini Component 3</div>',
                        beforeRouteEnter(to, from, next){
                            if(to.matched.some(record => record.meta.login)){
                                if(!user.login){
                                    alert('Halaman ini hanya untuk user!')
                                    next(false)
                                } else if(user.login && user.role == null){
                                    alert('Halaman ini hanya untuk admin!')
                                    next(false)
                                } else if(user.login && user.role == 'admin')
                                    alert('Berhasil masuk sebagai admin')
                                    next()
                            } else {
                                next()
                            }
                        } }

        const routes = [
            { path: '/comp1', component: Comp1},
            { path: '/comp2', component: Comp2, meta: { login: true }},
            { path: '/comp3', component: Comp3, meta: { login: true }}
        ]
        const router = new VueRouter({
            routes
        })
        var vm = new Vue({
            el: '#app',
            router
        })
    </script>
</body>
</html>